package org.bitbucket.bradleysmithllc.etlunit.feature.hsqldb_database;

import com.google.inject.Injector;
import org.bitbucket.bradleysmithllc.etlunit.feature.FeatureModule;
import org.bitbucket.bradleysmithllc.etlunit.feature.AbstractFeature;
import org.bitbucket.bradleysmithllc.etlunit.feature.database.DatabaseFeatureModule;

import javax.inject.Inject;
import java.util.Arrays;
import java.util.List;

@FeatureModule
public class HSQLDBDatabaseFeatureModule extends AbstractFeature {
	private static final List<String> prerequisites = Arrays.asList("logging", "database");
	private DatabaseFeatureModule databaseFeatureModule;
	private HSQLDBDatabaseImplementation hsqldbDatabaseImplementation;

	@Inject
	public void setDatabaseFeatureModule(DatabaseFeatureModule module)
	{
		databaseFeatureModule = module;
	}

	@Override
	public List<String> getPrerequisites() {
		return prerequisites;
	}

	@Override
	public void dispose()
	{
		hsqldbDatabaseImplementation.dispose();
	}

	@Override
	public void initialize(Injector inj)
	{
		hsqldbDatabaseImplementation = postCreate(new HSQLDBDatabaseImplementation());
		databaseFeatureModule.addDatabaseImplementation(hsqldbDatabaseImplementation);
	}
}